
/*# m4 allows C-style macro names, like _10 but not other punctuation marks
#	which is just as well since this has to go through `as' also

# Registers

# core, Ha3sm VM, multiple names for some regs 
*/






		
		




/*
# instuction name transliterations
*/









































































		# meta-insn sorta
























/*
# sugar
*/

/*
# gas directives transliterations 
*/








/* 
sub-atomics
*/






 /* aaaaaaaaaaaaa   aaaaa     aaaa	aaaaaaaaaaaaaaaaa
Ha3sm 1.4.m4

assembly language, bootable x86 version

*/


	 /* bytes in an address cell */







.org 0x7e00             
			/*# This means we'll have to trim the
                        #    binary with dd or something. Well worth it.
                        #    After   as   and   objcopy -O binary   do
                        #    dd < a.out > whatever bs=512 skip=62
			# The same effect can be had by appending to
			#  Janet Reno and building her
			
			# This should actually be PIC. For just a
			#   scheduler Ha3sm this should suffice.

			*/
.code32
.global _start
_start:

 /* MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN MAIN
there needs to be executable code at 7e00
*/



					/* data byte stack, byte access array */
ds:  		.org . + 0x2000
					/* byte-only data stack, everything gets
					converted to bytes internally in this
					implementation.	 */
ps:		.org . + 1024		/* the pointer stack itself, an array of
					 *****ints*******	   */


 /* CONFIGURATION SWITCH  CONFIGURATION SWITCH
endianism stuff, change $1 $2 $3 $4 to $4 $3 $2 $1 for big-endian,
(after	Michael Somos). In re 64-bit etc. I'm open to advice.  */



 /* cpp/C macros for within atoms */








 /* comment-anywhere macros */

			/* overwrite TOS with cell above TOS */


 /*  ######  pyte arithmatic    */

bytes:		 	.org . + 256

modulo:			.org . + 256
accum:			.org . + 256
head:			.org . + 16

 
			/* digits up to base 16. I prefer lowercase. 
			Also, e.g. FF is then a WORD only. Handy. 	*/
digitOut:		.ascii   "0123456789abcdef"


			/* to save syscalling write on each digit 	*/
numberString: 		.org . + 512


			/* convert.[bi] bytes-to-int zone 		*/
convert:		.org . + 4




 /*		NEXT NEXT NEXT NEXT NEXT NEXT NEXT
 In a real CPU the instruction pointer is incremented over code
automatically by every instruction. In a software Forthoid, the NEXT code
snippet at the end of each primitive does this. This is also called the
"inner interpreter", or address interpreter. 
*/



 /* set commandline args as H3m parse bounds. H3m `token' works vis-a-vis
	unix "whitespace".						
*(int *)&&epal	  = (int)argv[argc+1] ;
*(int *)&&thisl	   = (int)argv[0];
*/

 /* basic variable initialization		
*(int *)&&dpaddy = (int)&&initial_HERE + 1000 ;
*(int *)&&latest = (int)&&initial_LATEST ;
*/


jmp  initial_HERE;

 /* The atoms are the actual runtime machine code of H3m. They are what
the NEXTs call, once H3m itself is running.  The following code has to be
*compiled* here, but where it gets called from and where it jumps to is
what the labels are for, so we skip it for now with a goto.  Everything we
need the real machine for should be in here.  We use gotos ( in NEXT
primarily), but in the manner of _uncooked_ spaghetti, i.e. the gotos of
the NEXTs of each word are laminar, not tangled. There are no cross-word
gotos or fall-throughts. Fall-throughs would be OK, but aren't necessary.
This breaks gcc jump-optimization, e.g. gcc -O1 will remove all the atoms.
H3m is almost un-optimizable anyway though, AFAICT. Apparently gcc produces
code by default that e.g. peephole optimizing can't improve on much.

For some words that need stack items they don't modify, I use
( required ||| consumed --- produced )	 e.g.	  over	  ( a b ||| --- a )

"|null" means "or no stack item". I wish stack comments were concise, but no
guarantees. Running stack comments within words are particularly ad-hoc.

!SIZE  means word probably modifies Size.

AARDVARK!  AARDVARK!  aardvark exists just to be un-'-able due to 0 count
byte, ie. no name, and/or code field, and to be the starting point for the
dictionary linking. Handrolled ( non-macro )  empty neck.
The way to terminate a namespace traversal is when an HNC has a 0 length
byte. :NONAME isn't a problem because that's not a linked thing at all,
is it?
*/


	1:
	0:
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.ascii "aardvark"
	.align 4, 0
	.int  0
	.int  0
aardvark:





 /* these need to take a C/asm name and a H3m name.
	These could be hand-adjusted for CELL other than 4  */







 /* The m4 pass is first. In most of these macros we compute the length of
the word name at m4-time, which means we need another macro if we need
escapes for .ascii's in asm, which look like name chars to m4. This is the
case for H3m names containing " or \  */



 /* this is a thread header vith a non-user bit for leaving
interpreter-only  words and such out of "words", i.e. mildly hidden. */





 /* "threading" words are analagous to Forth immediate words */



 /*
real fundamentals/primitives...
possible other primitives; move, fill, endianism converters, charsearch
 aaaaaaaaaaaaaaaaaaaaaaaaaaaa================= */

 /* comments formatted for Glossary ggggggggggggggggggggGGGGGGGGGGGgggg */
/* glossary may include NON_USER words "words" hides.			*/
/* H3m is case-sensitive. Booleans OR, AND, XOR and NOT are uppercase.	*/
/* H3m abbreviation/pronounciation  conventions:			*/
/* */
/*	?      @	!	->	.	&	'	$	*/
/*	ask    fetch	store	to	print	append	tick	segment	*/
/* */
/* & (append) is to Forth `comma' as assemble is to compile.		*/
/* @ is usually a copy, -> is usually a move or pop, source is dropped. */
/* & in stack comments, e.g. &HNC, sometimes means "address of"		*/
/* ||| means "stuff to the left is required but not changed".		*/
/* ?* words like ?char etc. (and flag) produce flagpytes.		*/
/* format		(optional fields, optional order)		*/
/* name		`pronounced'  stacks effects  "parsing syntax"  notes*/
/* */
/*	ATOMS... */

 /*============================================= */
 /*================= ?word'able dictionary ============================ */


/* address	(P --- ptr ) !rsi  action of named data, Forth VARIABLE */
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"lea"
	.align	4, 0
	.int	0b
	.equ	leaCFA, .
lea:
		      /*      (P --- ptr )

Push our DFA address. analogue of Forth "dovar", but to pointer stack */

ret ; 


 /*============================================= */

/* AND		( pytea pyteb ---  aANDb ) the bitwise Boolean		*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"AND"
	.align	4, 0
	.int	1b
	.equ	ANDCFA, .
AND:


 /* example partial optimization using GNU C compound lvalues and
	taking the address of an array (ds0), allowing accessing a
	byte array as ints. 
*/

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* aint		( flagp --- !flagp ) casual NOT, bitwise on lsB.	*/
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"aint"
	.align	4, 0
	.int	0b
	.equ	aintCFA, .
aint:

ret ; 

 /*============================================= */

/* align		(P  a  --- a_rounded_up_to_CELLSIZE)		*/
   
	0:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"align"
	.align	4, 0
	.int	1b
	.equ	alignCFA, .
align:

ret ; 

 /*============================================= */

/* bump		( ---  old_pyte ) undrop. Only useful in threads. */
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"bump"
	.align	4, 0
	.int	0b
	.equ	bumpCFA, .
bump:

ret ; 

 /* =============================== */

/* bbytesd	bump 1->Size drop      */
   
	0:
	.byte	7
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"bbytesd"
	.align	4, 0
	.int	1b
	.equ	bytes_bdCFA, .
bytes_bd:

ret ; 


 /* =============================== */

/* bcellsd	bump sizeof(int)->Size drop	 */
  
	1:
	.byte	7
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"bcellsd"
	.align	4, 0
	.int	0b
	.equ	cells_bdCFA, .
cells_bd:

ret ; 


 /* =============================== */

/* cells		sizeof(int) -> Size		*/
   
	0:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"cells"
	.align	4, 0
	.int	1b
	.equ	cellsCFA, .
cells:

ret ; 


  /*============================================= */

/* drop		( pyte --- )			*/
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"drop"
	.align	4, 0
	.int	0b
	.equ	dropCFA, .
drop:

ret ; 


 /*============================================= */

/* dup		( pytea ||| ---	 pytea )  i.e.	  ( a --- a a )	   */
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"dup"
	.align	4, 0
	.int	1b
	.equ	dupCFA, .
dup:

mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* downshift	( shiftee amount --- shifted ) down-significance bitshift*/
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"shr"
	.align	4, 0
	.int	0b
	.equ	dshiftCFA, .
dshift:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* double		up-roll Size by 1, > 256 wraps	*/
   
	0:
	.byte	6
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"double"
	.align	4, 0
	.int	1b
	.equ	dubbleCFA, .
dubble:

ret ; 


 /*============================================= */

/* doHNC		(P &HNC	 --- ) (R; --- RET|null) execute word given &HNC */
  
	1:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"doHNC"
	.align	4, 0
	.int	0b
	.equ	doHNCCFA, .
doHNC:



 /*============================================= */

/* emit		(pyte --- )  ascii print lsB. not buffered.    */
   
	0:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"emit"
	.align	4, 0
	.int	1b
	.equ	emitCFA, .
emit:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* ell		unconditional branch to address in next thread cell */
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"ell"
	.align	4, 0
	.int	0b
	.equ	ellCFA, .
ell:

ret ; 


 /*============================================= */

/* false		( --- 0flagpyte )  fast false lsB  */
   
	0:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"false"
	.align	4, 0
	.int	1b
	.equ	falseCFA, .
false:


mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* @		(P ptr ||| --- ) ( --- pyte ) fetch pyte at ptr at Size */
  
	1:
	.byte	1
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"@"
	.align	4, 0
	.int	0b
	.equ	fetchCFA, .
fetch:


mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* @+		(P ptr --- ptr+Size ) ( --- pyte )		 */
   
	0:
	.byte	2
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"@+"
	.align	4, 0
	.int	1b
	.equ	fetchplusCFA, .
fetchplus:

				/* Bubb^H^H^H Chuck likes it	*/
mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* getSize	(P --- Size )	 */
  
	1:
	.byte	7
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"getSize"
	.align	4, 0
	.int	0b
	.equ	getSizeCFA, .
getSize:

ret ; 


 /*============================================= */

/* gap		(P a b ||| ) ( --- a-b ) bytes between addresses */
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"gap"
	.align	4, 0
	.int	1b
	.equ	gapCFA, .
gap:

mov %edi , %esi
	add %edx , %edi 
ret ; 

 /*============================================= */

/* halve		down-roll Size by 1 bit, i.e. Size=Size/2 usually*/
  
	1:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"halve"
	.align	4, 0
	.int	0b
	.equ	halveCFA, .
halve:

ret ; 


 /*============================================= */

/* Ha3sm	no-op. No action besides increment VM instruction pointer */
   
	0:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"Ha3sm"
	.align	4, 0
	.int	1b
	.equ	Ha3smCFA, .
Ha3sm:

ret ; 


 /*============================================= */

/* flag		( pyte --- flagpyte ) OR pyte into lsB, make it a flag */
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"flag"
	.align	4, 0
	.int	0b
	.equ	flagCFA, .
flag:

ret ; 


 /*============================================= */

/* ?()=		(P &a &b ||| ) ( ---  flag ) compare pointed-to pytes	*/
   
	0:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"?()="
	.align	4, 0
	.int	1b
	.equ	ifcontentsequalCFA, .
ifcontentsequal:

			/* HAS been seen to produce 2 different flags */
mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* ?=		( a b --- flagpyte ) 0xXX..ff (true) if a = b  */
  
	1:
	.byte	2
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"?="
	.align	4, 0
	.int	0b
	.equ	ifequalCFA, .
ifequal:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* ?positive	( a  --- flagpyte )  0 considered positive  */
   
	0:
	.byte	9
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"?positive"
	.align	4, 0
	.int	1b
	.equ	ifpositiveCFA, .
ifpositive:

ret ; 


 /*============================================= */

/* ip+		( ip_index --- ) execution-array mechanism, computed goto */
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"ip+"
	.align	4, 0
	.int	0b
	.equ	ipplusCFA, .
ipplus:

mov %edi , %esi
        sub %edx , %edi 
ret ; 	/* CASE BRANCH */


  /* ============================================= */

/* literal	( --- pyte )  in-thread literal pyte number to ds
	works at Size 4 and 1 */
   
	0:
	.byte	7
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"literal"
	.align	4, 0
	.int	1b
	.equ	literalCFA, .
literal:


mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* max		( a b --- maxab ) Min's hubby.			*/
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"max"
	.align	4, 0
	.int	0b
	.equ	maxCFA, .
max:


ret ; 		/* no bytes differ, numbers equal, finito. */


 /*============================================= */

/* min		( a b --- min_ab) Max's better half.		*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"min"
	.align	4, 0
	.int	1b
	.equ	minCFA, .
min:

ret ; 		/* no bytes differ, numbers equal, finito. */


 /*============================================= */

/* maskbyte	( a --- a&0x00...00ff ) mask off all but lsB   */
  
	1:
	.byte	8
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"maskbyte"
	.align	4, 0
	.int	0b
	.equ	maskbyteCFA, .
maskbyte:

ret ; 


 /*============================================= */

/* move		(P from to |||) (cnt ---)  move cnt bytes, overlaps are OK.
			You can't use this with the input buffer and 'this' */
   
	0:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"move"
	.align	4, 0
	.int	1b
	.equ	moveCFA, .
move:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* -?r		( --- flagpyte )  (R c --- c-1) is TOR nonzero before decrement?*/
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"-?r"
	.align	4, 0
	.int	0b
	.equ	minusaskrCFA, .
minusaskr:

mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* NOT		( pyte --- !pyte )   bitwise NOT of all bits	*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"NOT"
	.align	4, 0
	.int	1b
	.equ	NOTCFA, .
NOT:

ret ; 


 /*============================================= */

/* negate		( a --- 2's_complement_negative_a )	*/
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"neg"
	.align	4, 0
	.int	0b
	.equ	negCFA, .
neg:

ret ; 


 /*============================================= */

/* no		( flagpyte --- ) branch to address in ip (the next cell) if 0  */
   
	0:
	.byte	2
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"no"
	.align	4, 0
	.int	1b
	.equ	noCFA, .
no:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* over		( a b --- a b a ) the Forth usual OVER, but on pytes.	*/
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"over"
	.align	4, 0
	.int	0b
	.equ	overCFA, .
over:

mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* onbits		( --- -1 )  all_ones pyte constant, 2's compl. -1 */
   
	0:
	.byte	6
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"onbits"
	.align	4, 0
	.int	1b
	.equ	onbitsCFA, .
onbits:

mov %edi , %esi
	add %edx , %edi 
ret ; 

 /*============================================= */

/* one		( --- 1	 ) 1 as a pyte constant	  */
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"one"
	.align	4, 0
	.int	0b
	.equ	oneCFA, .
one:

mov %edi , %esi
	add %edx , %edi 
ret ; 

 /*============================================= */

/* OR		( pytea pyteb --- pyteaORb ) bitwise Booolean OR    */
   
	0:
	.byte	2
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"OR"
	.align	4, 0
	.int	1b
	.equ	ORCFA, .
OR:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* pdrop		(P ptr --- )  decrement pointer stack index */
  
	1:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"pdrop"
	.align	4, 0
	.int	0b
	.equ	pdropCFA, .
pdrop:

ret ; 


 /*============================================= */

/* p@		(P ptr1	 ---  ptr2 ) ptr1 overwritten */
   
	0:
	.byte	2
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p@"
	.align	4, 0
	.int	1b
	.equ	pfetchCFA, .
pfetch:

ret ; 


 /*============================================= */

/* pdup		(P ptra --- ptra ptra )	 */
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"pdup"
	.align	4, 0
	.int	0b
	.equ	pdupCFA, .
pdup:

ret ; 


 /*============================================= */

/* pliteral	(P --- lit )	next cell in thread to P.
		pointless from interpreter, needs a threading wrapper. */
   
	0:
	.byte	8
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"pliteral"
	.align	4, 0
	.int	1b
	.equ	pliteralCFA, .
pliteral:

ret ; 


 /*============================================= */

/* +		( a b --- a+b )	 2's-complement addition of pytes  */
  
	1:
	.byte	1
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"+"
	.align	4, 0
	.int	0b
	.equ	adcCFA, .
adc:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* pover		`pea over'  (P a b --- a b a ) pointer-stack OVER */
   
	0:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"pover"
	.align	4, 0
	.int	1b
	.equ	poverCFA, .
pover:

ret ; 


 /*============================================= */

/* p+		( pyte --- ) (P a --- a+(int_part_or_less_of)pyte ) */
  
	1:
	.byte	2
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p+"
	.align	4, 0
	.int	0b
	.equ	pluspCFA, .
plusp:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* p+s		(P a --- a+Size ) index a pointer by Size	*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p+s"
	.align	4, 0
	.int	1b
	.equ	pplussCFA, .
ppluss:

ret ; 


 /*============================================= */

/* p+1		(P a --- a+1 )	index a pointer by one		*/
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p+1"
	.align	4, 0
	.int	0b
	.equ	pplusbCFA, .
pplusb:

ret ; 


 /*============================================= */

/* p+c		(P a --- a+cellsize ) index a pointer by cellsize (x86 is 4) */
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p+c"
	.align	4, 0
	.int	1b
	.equ	ppluscCFA, .
pplusc:

ret ; 


 /*============================================= */

/* p-c		(P a --- a-cellsize ) decrement pointer by cellsize (4 on x86) */
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p-c"
	.align	4, 0
	.int	0b
	.equ	pminuscCFA, .
pminusc:

ret ; 


 /*============================================= */

/* p-1		(P ptr --- ptr+1 ) decrement a pointer			*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p-1"
	.align	4, 0
	.int	1b
	.equ	pminus1CFA, .
pminus1:

ret ; 


 /*============================================= */

/* p->		(P a --- ) ( --- a_low[a_hi] ) if (Size > cellsize) then 0-pad	*/

  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p->"
	.align	4, 0
	.int	0b
	.equ	pTOCFA, .
pTO:

mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* p->r		(P a --- ) (R; --- a ) */
   
	0:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p->r"
	.align	4, 0
	.int	1b
	.equ	pTOrCFA, .
pTOr:

ret ; 


 /*============================================= */

/* p->s		(P Size --- )  !Size   superceeded?	*/
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p->s"
	.align	4, 0
	.int	0b
	.equ	pTOsCFA, .
pTOs:

ret ; 


 /*============================================= */

/* p!		`pea store' (P p  store	 |||  ) p goes in store, no pdrops  */
   
	0:
	.byte	2
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"p!"
	.align	4, 0
	.int	1b
	.equ	pstoreCFA, .
pstore:

ret ; 


 /*============================================= */

/* pswap		(P a b --- b a )	*/
  
	1:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"pswap"
	.align	4, 0
	.int	0b
	.equ	pswapCFA, .
pswap:

ret ; 


 /*============================================= */

/* pup		(P ---	oldptr )  pointer stack undrop			*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"pup"
	.align	4, 0
	.int	1b
	.equ	pupCFA, .
pup:

ret ; 


 /*============================================= */

/* return		(R; xt	--- )  VMST rts to calling thread   */
  
	1:
	.byte	6
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"return"
	.align	4, 0
	.int	0b
	.equ	ReturnCFA, .
Return:

ret ; 				/* goto **ip++; */


 /*============================================= */

/* rdrop		(R; a --- ) */
   
	0:
	.byte	5
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"rdrop"
	.align	4, 0
	.int	1b
	.equ	rdropCFA, .
rdrop:

ret ; 


 /*============================================= */

/* rpcopy		(R; a ||| ) (P --- a ) dup r to p   */
  
	1:
	.byte	6
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"rpcopy"
	.align	4, 0
	.int	0b
	.equ	rpcopyCFA, .
rpcopy:

ret ; 


 /*============================================= */

 /* r-1		(R: val --- val-1 )  decrement TOR
ATOM_(rminus1,r-1)
NEXT */


 /*============================================= */

/* <-r		(R; val --- ) ( --- 0000val )  4 live bytes written to ds  */
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"<-r"
	.align	4, 0
	.int	1b
	.equ	rTOCFA, .
rTO:

mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* r->p		(R; ptr --- ) (P --- ptr ) symmetrical with p->r. */
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"r->p"
	.align	4, 0
	.int	0b
	.equ	rTOpCFA, .
rTOp:

ret ; 


 /*============================================= */

/* r->s		(R; size --- )	!SIZE */
   
	0:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"r->s"
	.align	4, 0
	.int	1b
	.equ	rTOsCFA, .
rTOs:

ret ; 


 /* ============================================= */

/* swap		( pytea pyteb --- pyteb pytea ) */
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"swap"
	.align	4, 0
	.int	0b
	.equ	swapCFA, .
swap:

ret ; 


 /*============================================= */

/* setSize	( Size --- )  Silently refuses to set Size to 0. */
   
	0:
	.byte	7
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"setSize"
	.align	4, 0
	.int	1b
	.equ	setSizeCFA, .
setSize:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* s->r		(R; --- Size ) Size to return stack		*/
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"s->r"
	.align	4, 0
	.int	0b
	.equ	sTOrCFA, .
sTOr:

ret ; 


 /*============================================= */

/* s->p		(P --- Size )  Size to pointer stack		*/
   
	0:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"s->p"
	.align	4, 0
	.int	1b
	.equ	sTOpCFA, .
sTOp:

ret ; 


 /*============================================= */
					/* Got milk? */

/* !		(P ptr ||| ) ( pyte --- ) pointer is not dropped */
  
	1:
	.byte	1
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"!"
	.align	4, 0
	.int	0b
	.equ	storeCFA, .
store:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /* ============================================= */

/* sub		(R; --- ip+ ) ip!   go subthread, other uses. Essence of VMST	*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"sub"
	.align	4, 0
	.int	1b
	.equ	subCFA, .
sub:

ret ; 				/*  goto **ip++ */


 /* ============================================= */

/* ->r		(R; --- val ) ( val --- ) Forth >r, ish. 4 bytes moved. */
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"->r"
	.align	4, 0
	.int	0b
	.equ	TOrCFA, .
TOr:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* ->code		(P &HNC --- Code_Body_Cell ) */
   
	0:
	.byte	6
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"->code"
	.align	4, 0
	.int	1b
	.equ	TOcodeCFA, .
TOcode:

ret ; 


 /*============================================= */

/* ->link		(P &HNC --- Link_Cell ) `to link' field */
  
	1:
	.byte	6
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"->link"
	.align	4, 0
	.int	0b
	.equ	TOlinkCFA, .
TOlink:

ret ; 


 /*============================================= */

/* ->p		(P --- CELL ) ( a --- ) CELLSIZE worth of a is moved  */
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"->p"
	.align	4, 0
	.int	1b
	.equ	TOpCFA, .
TOp:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* true		( --- true_flagpyte ) 0xXXX...ff, true flag pyte constant  */
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"true"
	.align	4, 0
	.int	0b
	.equ	trueCFA, .
true:

mov %edi , %esi
	add %edx , %edi 
ret ; 


 /*============================================= */

/* 2pdrop		(P  A B --- )  drop 2 pointers. */
   
	0:
	.byte	6
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"2pdrop"
	.align	4, 0
	.int	1b
	.equ	twopdropCFA, .
twopdrop:

ret ; 

 /*============================================= */

/* upshift	( shiftee amount ---  up-shifted-lo [up-shifted-high] ) */
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"sal"
	.align	4, 0
	.int	0b
	.equ	salCFA, .
sal:

mov %edi , %esi
        sub %edx , %edi 					/* dsi is shiftee */
ret ; 

  /*============================================= */

/* x		( pyte --- ) print & drop a pyte, Forth "." but hex only */
   
	0:
	.byte	1
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"x"
	.align	4, 0
	.int	1b
	.equ	printhexCFA, .
printhex:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


  /*============================================= */

/* XOR		( pytea pyteb --- pyteaXORb ) bitwise exclusive-or	*/
  
	1:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"XOR"
	.align	4, 0
	.int	0b
	.equ	XORCFA, .
XOR:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*=============================================		*/

/* yes		( flagpyte --- )  branch if (lsB of) TOS is true	*/
   
	0:
	.byte	3
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"yes"
	.align	4, 0
	.int	1b
	.equ	yesCFA, .
yes:

mov %edi , %esi
        sub %edx , %edi 
ret ; 


 /*============================================= */

/* zero		( --- 0 )   0 as a fast pyte-constant  */
  
	1:
	.byte	4
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"zero"
	.align	4, 0
	.int	0b
	.equ	zeroCFA, .
zero:


mov %edi , %esi
	add %edx , %edi 
ret ; 


   
	0:
	.byte	10
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"<<<THREADS"
	.align	4, 0
	.int	1b
	.equ	thxbtixioCFA, .
thxbtixio:


 /* 7777777777777777777777777777777777777777777777777777 */
 /* end of dictionary build section for fundamentals/atoms/primitives.
Begin derived words; threads, named noun instances. The above is the
virtual machine, The non-syscall atoms are the virtual CPU.  the following
are some things you can do with said machine. Compiled-in threads are
written in the assembly language of the VM. Note that some of this
proto-H3m code is very un-Forth-like, doing many things wrong. That's
because H3m doesn't really exist yet, just the VM. So, it's nasty
tortuous virtual assembly. As far as examples of using the H3m
interpreter, Note the opcodes used, but ignore the coding style. Very
important in Virtual Machine Subroutine Threading, above here (by default)
words have the atomic bit set in the Head Name Interface Cell.
m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4m4

m4 macros for all the standard build_a_thread stuff.		*/

 /* contents of this int is given by  arg			*/


 /* this cell contains CFA of word named as argument		*/


 /* VMST jsr, takes a whole cell, plus the callee's cell
This doesn't have the OP folded into it to keep branch offset counting
1:1, except for branch targets. ___o___				*/


 /* build a relative branch offset with integer arg,
$1 is +/-, $2 is #   +/- needs a comma */


 /* we are at a branch target, set label symbols for here.
targets take no thread space themselves.
The graphicoid name is to emphasize that a cell is not created.	 */


 /* back-branch address of labels. arg-less macro. */


/* */
/*	NAMED DATA... */
 /* ddddddddddddddddddddddddddddddd============			*/

 
/* block		(P --- begin_buffer) object data buffer(s) */
  
	1:
	.byte 5
	.byte 0
	.byte 0
	.byte 0
	.ascii "block"
	.align 4, 0
	.int  0b
	.equ	blockCFA, .

.int leaCFA 
.int 0 ; 
	.org . + 1024 


/* buffer		(P --- begin_buffer) "file" input buffer */
  
	0:
	.byte 6
	.byte 0
	.byte 0
	.byte 0
	.ascii "buffer"
	.align 4, 0
	.int  1b
	.equ	bufferCFA, .

.int leaCFA 
.int 0 ; 
	.org . + 2048 


/* bsi		counter for branches to resolve		*/
  
	1:
	.byte 3
	.byte 0
	.byte 0
	.byte 0
	.ascii "bsi"
	.align 4, 0
	.int  0b
	.equ	bsiCFA, .

.int leaCFA 
.int 0 ; 


/* branchstack	space for 16 branches to resolve	*/
  
	0:
	.byte 11
	.byte 0
	.byte 0
	.byte 0
	.ascii "branchstack"
	.align 4, 0
	.int  1b
	.equ	branchstackCFA, .

.int leaCFA 
.int 0 ; 
	.org . + 128 
	/* allot for a maximal pyte */


/* digits		(P  ---	 address_of_array ) ascii vals to hex vals map	*/
  
	1:
	.byte 6
	.byte 0
	.byte 0
	.byte 0
	.ascii "digits"
	.align 4, 0
	.int  0b
	.equ	digitsCFA, .

.int leaCFA 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ;  
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.byte 0x00
		.byte 0x01
		.byte 0x02
		.byte 0x03 
.byte 0x04
		.byte 0x05
		.byte 0x06
		.byte 0x07 
.byte 0x08
		.byte 0x09
		.byte 0x00
		.byte 0x00 
.int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.byte 0x00
		.byte 0x0a
		.byte 0x0b
		.byte 0x0c 
.byte 0x0d
		.byte 0x0e
		.byte 0x0f
		.byte 0x00 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 


/* dp		(P --- dictionary_free-point_pointer )  pointer, unlike HERE  */
  
	0:
	.byte 2
	.byte 0
	.byte 0
	.byte 0
	.ascii "dp"
	.align 4, 0
	.int  1b
	.equ	dpCFA, .

.int leaCFA 
dpaddy:		/* we have to poke a number in here at init time */
.int 0 ; 


/* epa		(P --- &epa )  End Parse Area	pointer		*/
  
	1:
	.byte 3
	.byte 0
	.byte 0
	.byte 0
	.ascii "epa"
	.align 4, 0
	.int  0b
	.equ	epaCFA, .

 /*  can't just keep these on a stack because of doHNC	  */
.int leaCFA 
epal:
.int 0 ; 


/* hexdigits	(P  ---	 &array )  ascii val is/not a hex digit	  */
  
	0:
	.byte 9
	.byte 0
	.byte 0
	.byte 0
	.ascii "hexdigits"
	.align 4, 0
	.int  1b
	.equ	hexdigitsCFA, .

       /* could be dual-aligned for unicode. someday. word-size dependant? */
.int leaCFA 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.byte 0xff
		.byte 0xff
		.byte 0xff
		.byte 0xff 
.byte 0xff
		.byte 0xff
		.byte 0xff
		.byte 0xff 
.byte 0xff
		.byte 0xff
		.byte 0x00
		.byte 0x00 
.int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.byte 0x00
		.byte 0xff
		.byte 0xff
		.byte 0xff 
.byte 0xff
		.byte 0xff
		.byte 0xff
		.byte 0x00 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 
.int 0  ;  .int 0  ;  .int 0  ;  .int 0  ; 


/* latest		(P --- &HNC ) addr. of HNC of most recent definition  */
  
	1:
	.byte 6
	.byte 0
	.byte 0
	.byte 0
	.ascii "latest"
	.align 4, 0
	.int  0b
	.equ	latestCFA, .

.int leaCFA 		/* data word, does it's own Return.  */
latest:			/* C needs this address for init code	 */
.int 0 ; 


/* pvar		(P --- &pvar)	scratch pointer for thread resolver  */
  
	0:
	.byte 4
	.byte 0
	.byte 0
	.byte 0
	.ascii "pvar"
	.align 4, 0
	.int  1b
	.equ	pvarCFA, .

.int leaCFA 
 .int 0 ; 


/* rcfile	(P --- &"rcfile")				*/
  
	1:
	.byte 6
	.byte 0
	.byte 0
	.byte 0
	.ascii "rcfile"
	.align 4, 0
	.int  0b
	.equ	rcfileCFA, .

.int leaCFA 
 .int 0 ; 
      	.asciz   "H3smrc" 
	.align 16, 0


/* sourc		(P --- &input_FD) pointer to FD of source of input */
  
	0:
	.byte 5
	.byte 0
	.byte 0
	.byte 0
	.ascii "sourc"
	.align 4, 0
	.int  1b
	.equ	sourcCFA, .

.int leaCFA  
.int 0 ; 
         .align 16, 0 


/* thispointer	(P --- &this ) current address in buffered parse area	*/
  
	1:
	.byte 11
	.byte 0
	.byte 0
	.byte 0
	.ascii "thispointer"
	.align 4, 0
	.int  0b
	.equ	thispointerCFA, .

.int leaCFA 
thisl:
.int 0 ; 


/* toklen		token length	*/
  
	0:
	.byte 6
	.byte 0
	.byte 0
	.byte 0
	.ascii "toklen"
	.align 4, 0
	.int  1b
	.equ	toklenCFA, .

.int leaCFA 
.int 0 ; 


/* targetstack	space for 8 addresses to resolve branches to */
  
	1:
	.byte 11
	.byte 0
	.byte 0
	.byte 0
	.ascii "targetstack"
	.align 4, 0
	.int  0b
	.equ	targetstackCFA, .

.int leaCFA 
.int 0 ; 
	.org . + 32 
	/* allot for a maximal pyte */


/* tokenbuffer	(P --- &token ) where we stash an input token   */
  
	0:
	.byte 2
	.byte 0
	.byte 0
	.byte 0
	.ascii "tb"
	.align 4, 0
	.int  1b
	.equ	tbCFA, .

.int leaCFA 
.int 0 ; 
	.org . + 1024 


/* tsi		counter for branches to resolve */
  
	1:
	.byte 3
	.byte 0
	.byte 0
	.byte 0
	.ascii "tsi"
	.align 4, 0
	.int  0b
	.equ	tsiCFA, .

.int leaCFA 
.int 0 ; 


/* USize		(P --- &USize ) offstack Size store for interpreter
					fetch as a pointer	  */
  
	0:
	.byte 5
	.byte 0
	.byte 0
	.byte 0
	.ascii "USize"
	.align 4, 0
	.int  1b
	.equ	USizeCFA, .

.int leaCFA 
.int 4 ; 				/* x86 cell size */


/* */
/*	THREADS...
*/
 /* TTTTTTTTTTTTTTTTTTTTTTTT============				*/

  /* ||||||| zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz||============ */

/* zygote		top endless loop, do argv[], do rcfile,  
				then loop over input */
initial_LATEST:		/* label at HNC for dist. init. */
  
	1:
	.byte 6
	.byte 0
	.byte 0
	.byte 0
	.ascii "zygote"
	.align 4, 0
	.int  0b
	.equ	zygoteCFA, .

		/* Head execution address, CFA, H3m square zero.
			*/
zygote:

.int onbitsCFA 

.equ top_loop_of_H3sm_one, .	
.int top_loop_of_H3sm_one	


 /* ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	*/

initial_HERE:

ret ; 			/* NEXT ourself to the interpreter... */

 



/*

Ha3sm 3-stack programming interface (virtual machine design) in m4,
	and GNU "as" for x86.

199804 <--> 200003   Rick Hohensee
humbubba@smart.net	http://www.smart.net/~humbubba

199812	 Michael Somos "http://grail.cba.csuohio.edu/~somos/"
	non-endianness, routine delimiter comment lines, etc.

See also Ertl/Paysan GForth and GNU .info on gcc "labels as values",
the unix section 2 manpages, Linux man 2 intro in particular, and the
GNU .info on gas.

The sourcecode of the "Arith" and "calc" arbitrary precision arithmetic
packages for unices were consulted for this implementation of pyte
arithmetic, although pytes are quite different from numbers in those
systems.

Phil Koopman's book "Stack Computers; The New Wave" bears mention. It is
currently on the web at "http://www.cs.cmu.edu/~koopman/stack_computers/".

Also worth mention are the generally meritocratic and cooperative tones of
comp.lang.forth, MdFIG and linux-kernel@vger.rutgers.edu. Greg Patterson
was helpful at a particularly frustrating moment with C pointers. Two
design features of H3m were suggested by JET Thomas; the single-whole-pass
dictionary search method used by abbreviations, and that pyte sizes go up
to 256 bytes instead of 128. Explanations by Elizabeth Rather and others
in c.l.f led to me eliminating H3m words that access the parameter stack
pointer directly, since a pure stack that has no concept of a "stack
pointer" is sufficient for a stack machine, and probably preferable.  I
had a copy of John Brien's "Build Your Own Forth" webpage in my
/usr/src/H3m . (original URL is
"http://www.users.zetnet.co.uk/aborigine/byof.htm")

The printer Charles Lasitter of Durham, N.C. gave me has done yeoman
service as an essential debugging tool. As have the several PS/2's,
the Pentium, and the cash. I believe the technical term for the likes
of Chuck Lasitter is "angel".

H3m has also recieved direct help from Richard B. Johnson, Brian Raiter,
and direct help or inspiration from various anonymous Internet Relay Chat
personages. The nom_de_IRC's _Anarchy_, tm2, shaver and * come to mind.

As pertains copyrights and release thereof, H3m is not a derived work of
any prior work.

This version of H3m is hereby released into the public domain. I am of
the understanding that "public domain" does not release users of H3m from
the obligation of properly associating my name with the work. Subsequent
work I do on H3m may be released under more restrictive terms.

DESIGN

Virtual Machine Subroutine Threaded H3m.
	All "executable" dictionary cells contain actual addresses of code.
	The address of a sub-word is in the callER, following a "call"
	execution token cell, which is not present in more prevalent
	threading schemes.

Each of the 3 "stacks" has a distinctly different related ops from the other
2.

return
	The return stack will contain only xt's. An xt is what NEXT can use,
	an address space int-ply index to an atom, which is machine code.

pointer
	The H3m pointer stack is cell-sized, but contains only actual host
	address-space pointers usually. Such an entity is called a "pointer"
	from the H3m-user point of view. The pointer stack may be a bridge
	between the H3m VM and the host, but only with specific fundamentals
	for host services, such as system calls. Internally, the pointer stack
	index is usually left pointing to an occupied cell.
data
	The data stack operates on "pytes", groups of 1 <--> 256
	bytes. Boolean flags are the low byte of a pyte. False is zero.
	Non-zero is true. The H3m   true   word asserts 255 in a flagpyte.
	The stack index itself is byte-ply, but pyte operations are at Size.
	The data stack pointer points at the top occupied cell. This is
	important to keep in mind when changing Size.

	Size "Register"

	The current effective size of data stack operands is the Size state
	variable. There are user-visible accessors of this Size "register".
	Operations on pytes are in terms of Size, except where a pyte is
	treated as a flag or character.

So the 3 stacks are the data typing of H3m, in a sense. Typing is enforced
by the various operands. The data stack is where a datum can be treated
arbitrarily.

IMPLEMENTATION

Early versions may depend on 4 byte address cell.  For big-endian CPU see
"CONFIGURATION SWITCH" below.  Initial implementation. REQUIRES *GNU* C.

This H3m is for x86. The CPU-specific code is not much, but it is spread
around, so I'm not going to attempt to isolate it with the cpp #include
mechanism. If someone ports H3m to another platform I'll include the
whole thing in the package if they want, or a patch. The approximate
minimum machine-specific stuff for a unix would be the the exit, write and
read syscalls, which are the int 0x80 instruction on x86 Linux. This H3m
needs those syscalls for several primitives te be usable at all, and has
the calls coded in situ where needed. After those you'll want argv/env
passing, which requires machine opcodes, and other syscalls. A
per-keystroke input mechanism probably wants ioctl to set the tty to raw
mode, for example. I think.

H3m NEXT uses gcc labels_as_values and computed goto. The Linux syscalls
use gcc C expressions in asm statements. The idiom of this code overall is
what I call <C, `less-than C'. ip is a C "pointer to int", as needed for
gcc goto **. It's the only pointer declaration in H3m.

As of this writing H3m assumes a 32 bit address cell, but I suspect that
can be macro'ed out for a configurable cell size with little bloodshed.
Some of that has been done already.

C slash-asterisk comments beginning in leftmost character column are
appended to the glossary file by the Glossary script.

*/
