/* Walk every byte in a file using a buffer. 
one-way walk, one byte at a time internally, buffered. This can be a
wrapper for things that backtrack, but do thier own state maintenance 
of whatever has to be backtracked. Prints byte offsets of newlines for
demo purposes. Files to 2 gig I guess.

interface: reads stdin, returns 0 for "no issues"

July 2000 Rick Hohensee

FIX ME  skips the 0 byte of the file.

			*/

#include <unistd.h>
#include <stdio.h>



#define USUALSIZE 	(1 << 15)
	/* unix newline	*/
#define NEWLINE		10 		

int cursor, absolute, got, buffersize;

char buffer[USUALSIZE];



int 
		more ()			/* read next bufferfull */ 
{
	cursor = 0;
	
	got =  read(0, buffer,USUALSIZE);
	if ( got == 0 )
		{ exit (0); }
} 


void
		step ()			/* point at next byte	*/
{
	if ( cursor == buffersize )
		{ got = more ();
		if ( got < USUALSIZE)
			{ buffersize = got ; }		
		}
	cursor++;
	absolute++;	 
}	


int 		
		main ()		/* print byte offsets of newlines */ 
{ 
	buffersize = USUALSIZE;
	more();
	while ( 1 == 1 )
		{ step();
				/* Your parser goes here 	*/
		if ( buffer[cursor] == NEWLINE )
			{ printf("%d   ", absolute);
			}
		}	
}
