/* 

#
#*VERY* cLIeNUX#
#
#Building programs that reference exact pathnames 
#	A: should be avoided
#	B: failing A:, should use these defines
#
#
#T#here also should be a very low-level hook to this file, such as in
#the default environment string in init/main.c in the kernel. How do
#you find everything without finding the map?
#
#PATHS_H=
#
# */

#ifndef _PATHS_H_
#define	_PATHS_H_

#define LINUX_SOURCE		/source/kernel/linux


#define	__PATH_ETC_INET	"/.et"

/* Default command search PATH. */
#define	_PATH_DEFPATH		"/.bi:/.sbi:/.bi/unix"
#define _PATH_DEFPATH_ROOT	".:/.bi:/.sbi:/.bi/unix"

#define	_PATH_BSHELL	"/.bi/sh"
#define	_PATH_CONSOLE	"/dev/console"
#define	_PATH_DEVDB	"/.va/run/dev.db"
#define	_PATH_DEVNULL	"/dev/null"
#define	_PATH_HEQUIV	__PATH_ETC_INET"/hosts.equiv"
#define	_PATH_KMEM	"/dev/kmem"
#define	_PATH_MAILDIR	"/.va/spool/mail"
#define	_PATH_MAN	"/help/see"
#define	_PATH_MEM	"/dev/mem"
#define	_PATH_LOGIN	"/.sbi/login"
#define	_PATH_NOLOGIN	"/.et/nologin"
#define	_PATH_SENDMAIL	"/.sbi/putmail"
#define	_PATH_SHELLS	"/.et/shells"
#define	_PATH_TTY	"/dev/tty"
#define	_PATH_UNIX	"/boot/kernel/default"
#define	_PATH_VI	"/.bi/edit"
#define	_PATH_PRESERVE	"/.va/preserve"

/* Provide trailing slash, since mostly used for building pathnames. */
#define	_PATH_DEV	"/dev/"
#define	_PATH_TMP	"/.tm/"
#define	_PATH_VARRUN	"/.va/run/"
#define	_PATH_VARTMP	"/.va/tmp/"




#define _PATH_KLOG	"/.pro/kmsg"
#define _PATH_LOGCONF	__PATH_ETC_INET"/syslog.conf"
#if 0
#define _PATH_LOGPID	__PATH_ETC_INET"/syslogd.pid"
#else
#define _PATH_LOGPID	"/.va/run/syslogd.pid"
#endif
#define _PATH_LOG	"/dev/log"
#define _PATH_CONSOLE	"/dev/console"

#define _PATH_UTMP	"/.va/utmp"
#define _PATH_WTMP	"/.va/log/wtmp"
#define _PATH_LASTLOG	"/.va/log/lastlog"

#define _PATH_LOCALE	"/.et/locale"

#define _PATH_RWHODIR	"/.va/rwho"

#if _MIT_POSIX_THREADS
#define _PATH_PTY	"/dev/"
#define _PATH_TZDIR	"/.us/.li/zoneinfo"
#define _PATH_TZFILE	"/.us/.li/zoneinfo/localtime"
#endif

#endif /* !_PATHS_H_ */
