/* print just the comments in C sourcecode files. Don't worry about 
C++ style comments */


#include <unistd.h>


int argc;
char ** argv;


int main(int argc, char * argv[])
{
int fd, red, i, j, incomment ;
char  previous, this, readbuffer[4096];

/*
assume all args are files
*/

if ( argc == 1)
	{ printf("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n
	
	outputs  the `/*'- delimited comments from C sourcecode.

	It takes commandline args. `comments' doesn't pipe.


	");
	return;
	}


for ( i = 1; i < argc ; i ++)
	{
	write(1,"\n\ncomments||||||| ",17 );
	write(1, argv[i], 10 );
	write(1," |||||||comments\n\n",17 );
 


	previous = 0;
	incomment = 0;
        fd = open( argv[i], 0 );

        red = -2 ;
        while ( red )                   /* buffer IO sans libc. pththtp  */
                {
                red = read(fd, readbuffer, 4096);
                if ( red == -1 )
                        break ;
                for (j = 0 ; j < red ; j++)
			{
			previous = this;
			this = readbuffer[j];
			if ( (previous == '*') && (this == '/' ) )
				{ incomment = 0 ;
				write(1,"\n",1);	
				}
			if ( (previous == '/') && (this == '*' )  )
				{ incomment = 1;
				write(1,"/",1);
				}
			if ( incomment )
				write(1,&readbuffer[j],1); 
                	}
		}
        } /* end files loop */

return 0;       /* turn off some compiler warning noise */
}               /* end of main, end of program code


Copyright 1999 Richard Allen Hohensee
This file is released for redistribution only as part of an intact 
entire cLIeNUX Core.


## pasteable build script
gcc -c comments.c
ld -nostdlib -o comments comments.o /.li/static/libsys.a /.li/static/arg_env.o
strip -R .comment -R .note comments
wc comments     ## */

