
include(asmacs)

 __( aaaaaaaaaaaaa   aaaaa     aaaa	aaaaaaaaaaaaaaaaa
Ha3sm 1.4.m4

assembly language, bootable x86 version

GNU as, GNU m4
)


define( STACKSIZE,	0x2000)


.org 0x7e00             
			__(`# This means we'll have to trim the
                        #    binary with dd or something. Well worth it.
                        #    After   as   and   objcopy -O binary   do
                        #    dd < a.out > whatever bs=512 skip=62
			# The same effect can be had by appending to
			#  Janet Reno and building her
			
			# This should actually be PIC. For just a
			#   scheduler Ha3sm this should suffice.

			')
_assembling_32
.global _start
_start:

 __( MAIN MAIN MAIN MAIN so to speak
there needs to be executable code at 7e00
)


increasing
jmp  initial_HERE;


					__( data byte stack, byte access array )
ds:  		.org . + STACKSIZE
					__( byte-only data stack, everything gets
					converted to bytes internally in this
					implementation.	 )
ps:		.org . + 1024		__( the pointer stack itself, an array of
					 *****ints*******	   )


 __(` CONFIGURATION SWITCH  CONFIGURATION SWITCH
endianism stuff, change 1 2 3 4 to 4 3 2 1 for big-endian,
after	Michael Somos. In re 64-bit etc. I'm open to advice.  
This is leftovers from the C version, but it may come in handy.')

define(ENDIANCELL,
		.byte $1
		.byte $2
		.byte $3
		.byte $4 )

 __(` cpp/C macros for within atoms ')

define(TRUE,	`BUMP' 		
		`movb  $255 to TOS' )

define(FALSE,	`BUMP '
		`copy $`'0 to TOS' )


 __(`  ######  pyte arithmatic spaces'   )

bytes:		 	.org . + 256
modulo:			.org . + 256
accum:			.org . + 256
head:			.org . + 16

		__( 
			digits up to base 16. I prefer lowercase. 
			Also, e.g. FF is then a WORD only. Handy. )

digitOut:		.ascii   "0123456789abcdef"


		__( to save syscalling write on each digit 	)
numberString: 		.org . + 512


		__(  bytes-to-int zone 		)
convert:		.org . + 4

__(
For some words that need stack items they don't modify, I use
( required ||| consumed --- produced )	 e.g.	  over	  ( a b ||| --- a )

"|null" means "or no stack item". I wish stack comments were concise, but no
guarantees. Running stack comments within words are particularly ad-hoc.

!SIZE  means word probably modifies Size.

AARDVARK!  AARDVARK!  aardvark exists just to be un-'-able due to 0 count
byte, ie. no name, and/or code field, and to be the starting point for the
dictionary linking. Handrolled ( non-macro )  empty neck.
The way to terminate a namespace traversal is when an HNC has a 0 length
byte. :NONAME isn't a problem because that's not a linked thing at all,
is it?
)


	1:
	0:
	.byte 0
	.byte 0
	.byte 0
	.byte 0
	.ascii "aardvark"
	.align 4, 0
	.int  0
	.int  0
aardvark:


define(`ALTLABEL', 0:)
define(`ALTREF', 1b )

 __( these need to take a C/asm name and a H3m name.
	These could be hand-adjusted for CELL other than 4  )

define(ATOM_,
`ifelse(ALTLABEL,0:, `define(`ALTLABEL', 1:)  define(`ALTREF', 0b)',
		    `define(`ALTLABEL', 0:)  define(`ALTREF', 1b)' )'
	`ALTLABEL'
	.byte	`len($2)'
	.byte	0
	.byte	0x80
	.byte	0
	.ascii	"`$2'"
	`.align	4, 0'
	.int	`ALTREF'
	.equ	`$1'CFA`, .'
`$1':
)

define(HATOM_,
`ifelse(ALTLABEL,0:, `define(`ALTLABEL', 1:)  define(`ALTREF', 0b)',
		    `define(`ALTLABEL', 0:)  define(`ALTREF', 1b)' )'
	`ALTLABEL'
	.byte	`len($2)'
	.byte	0
	.byte	0x80
	.byte	1
	.ascii	"`$2'"
	`.align	4, 0'
	.int	`ALTREF'
	.equ	`$1'CFA`, .'
`$1':
)

define(THREAD_,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
			`define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'
	`ALTLABEL'
	.byte `len($2)'
	.byte 0
	.byte 0
	.byte 0
	.ascii "`$2'"
	`.align 4, 0'
	.int  `ALTREF'
	.equ	`$1'CFA`, .'
)

define(THREADING_NAMELEN,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
			`define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'

	`ALTLABEL'
	.byte $3
	.byte 1
	.byte 0
	.byte 0
	.ascii "`$2'"
	`.align 4, 0'
	.int  `ALTREF'
	.equ	`$1'CFA`, .'
)

 __( this is a thread header vith a non-user bit for leaving
interpreter-only  words and such out of "words", i.e. mildly hidden. )

define(NON_USER,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
			`define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'
	`ALTLABEL'
	.byte `len($2)'
	.byte 0
	.byte 0
	.byte 1
	.ascii "`$2'"
	`.align 4, 0'
	.int  `ALTREF'
	.equ	`$1'CFA`, .'
)


 __( "threading" words are analagous to Forth immediate words )

define(THREADING,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
			`define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'

	`ALTLABEL'
	.byte `len($2)'
	.byte 1
	.byte 0
	.byte 0
	.ascii "`$2'"
	`.align 4, 0'
	.int  `ALTREF'
	.equ	`$1'CFA`, .'
)

 __(
real fundamentals/primitives...
possible other primitives; move, fill, endianism converters, charsearch
 aaaaaaaaaaaaaaaaaaaaaaaaaaaa================= )

 __( comments formatted for Glossary ggggggggggggggggggggGGGGGGGGGGGgggg )
__( glossary may include NON_USER words "words" hides.			)
__( H3m is case-sensitive. Booleans OR, AND, XOR and NOT are uppercase.	)
__( H3m abbreviation/pronounciation  conventions:			)
__( )
__(	?      @	!	->	.	&	'	$	)
__(	ask    fetch	store	to	print	append	tick	segment	)
__( )
__( & (append) is to Forth `comma' as assemble is to compile.		)
__( @ is usually a copy, -> is usually a move or pop, source is dropped. )
__( & in stack comments, e.g. &HNC, sometimes means "address of"	)
__( ||| means "stuff to the left is required but not changed".		)
__( ?* words like ?char etc. (and flag) produce flagpytes.		)
__( format		(optional fields, optional order)		)
__( name		`pronounced'  stacks effects  "parsing syntax"  notes)
__( )
__(	ATOMS... )

 __(============================================= )
 __(================= ?word'able dictionary ============================


Primitives are atomic, and thus don't have to be re-entrant internally.
 )


__( address	(P --- ptr ) !rsi  action of named data, Forth VARIABLE )
ATOM_(address,address)		      __(      (P --- ptr )

Push our DFA address. analogue of Forth "dovar", but to pointer stack )
			
		return


 __(============================================= )

__( AND		( pytea pyteb ---  aANDb ) the bitwise Boolean
)
ATOM_(AND,AND)
		setPTOS
		DROP
		return


 __(============================================= )

__( aint		( flagp --- !flagp ) casual NOT, bitwise on lsB.
)
ATOM_(aint,aint)
		xorl $0x000000ff to TOS
		return

 __(============================================= )

__( align		(P  a  --- a_rounded_up_to_CELLSIZE)		)
ATOM_(align,align)
		ADD $3 to (PSI)
		AND $0xfffffffe to (PSI)
		return

 __(============================================= )

__( bump		( ---  old_pyte ) undrop. Only useful in threads.
)
ATOM_(bump,bump)
		BUMP
		return

 __( =============================== )

__( bbytesd	bump 1->Size drop      )
ATOM_(bytes_bd,bbytesd)
		BUMP
		copy $1 to Size
		DROP
		return


 __( =============================== )

__( bcellsd	bump sizeof(int)->Size drop	 )
ATOM_(cells_bd,bcellsd)
		BUMP
		copy cellsize to Size
		DROP
		return


 __( =============================== )

__( cells		sizeof(int) -> Size		)
ATOM_(cells,cells)
		copy cellsize to Size	
		return


  __(============================================= )

__( drop		( pyte --- )			)
ATOM_(drop,drop)
		DROP
		return


 __(============================================= )

__( dup		( pytea ||| ---	 pytea )  i.e.	  ( a --- a a )	   )
ATOM_(dup,dup)
		copy SI to source
		copy Size to counter
		BUMP
		copy SI to dest
		repeating 
		movsb 
		return


 __(============================================= )

__( downshift	( shiftee amount --- shifted ) down-significance bitshift)
ATOM_(dshift,downshift)

		__( Here we encouter one of the ugliest aspects of an
		ugly architecture. From Ha3sm's point of view anyway. 
		The shift amount is where the loop 
		instruction counter would otherwise be, so loop and
		ret are unavailable for shifts.
		HINT:  exchange     )

movb TOS to %ecx	__( set shift amount )				
DROP


_downshift_:
	

	
	shrd %cl,%eax,(%edx) 
	

loop _downshift_
return


 __(============================================= )

__( double		up-roll Size by 1, > 256 wraps	)
ATOM_(dubble,double)
return


 __(============================================= )

__( doHNC		(P &HNC	 --- ) (R; --- RET|null) execute word given &HNC )
ATOM_(doHNC,doHNC)



 __(============================================= )

__( emit		(pyte --- )  ascii print lsB. not buffered.    )
ATOM_(emit,emit)
DROP
return


 __(============================================= )

__( ell		unconditional branch to address in next thread cell )
ATOM_(ell,ell)
return		__( inline this? )		


 __(============================================= )

__( false		( --- 0flagpyte )  fast false lsB  )
ATOM_(false,false)
		FALSE
		return


 __(============================================= )

__( @		(P ptr ||| --- ) ( --- pyte ) fetch pyte at ptr at Size )
ATOM_(fetch,@)

BUMP
return


 __(============================================= )

__( @+		(P ptr --- ptr+Size ) ( --- pyte )		 )
ATOM_(fetchplus,@+)
				__( Bubb^H^H^H Chuck likes it	)
BUMP
return


 __(============================================= )

__( getSize	(P --- Size )	 )
ATOM_(getSize,getSize)
PBUMP
copy Size to (,PSI scaled_by cellsize)
return


 __(============================================= )

__( gap		(P a b ||| ) ( --- a-b ) bytes between addresses )
ATOM_(gap,gap)
BUMP
return

 __(============================================= )

__( halve		down-shift Size by 1 bit, Size=Size/2 usually)
ATOM_(halve,halve)
shr $1, Size
return


 __(============================================= )

__( Ha3sm	no-op. No action besides increment VM instruction pointer )
ATOM_(Ha3sm,Ha3sm)
		return


 __(============================================= )

__( flag		( pyte --- flagpyte ) OR pyte into lsB, make it a flag )
ATOM_(flag,flag)
		return


 __(============================================= )

__( ?()=		(P &a &b ||| ) ( ---  flag ) compare pointed-to pytes	)
ATOM_(ifcontentsequal,``?()''=)
			__( HAS been seen to produce 2 different flags )
		BUMP
		return


 __(============================================= )

__( ?=		( a b --- flagpyte ) 0xXX..ff (true) if a = b  )
ATOM_(ifequal,?=)
		DROP
		return


 __(============================================= )

__( ?positive	( a  --- flagpyte )  0 considered positive  )
ATOM_(ifpositive,?positive)
return


 __(============================================= )

__( ip+		( ip_index --- ) execution-array mechanism, computed goto )
ATOM_(ipplus,ip+)
DROP
return	__( CASE BRANCH )


  __( ============================================= )

__( literal	( --- pyte )  in-thread literal pyte number to ds
	works at Size 4 and 1 )
ATOM_(literal,literal)

BUMP
return


 __(============================================= )

__( max		( a b --- maxab ) Min's hubby.			)
ATOM_(max,max)

return		__( no bytes differ, numbers equal, finito. )


 __(============================================= )

__( min		( a b --- min_ab) Max's better half.		)
ATOM_(min,min)
return		__( no bytes differ, numbers equal, finito. )


 __(============================================= )

__( maskbyte	( a --- a&0x00...00ff ) mask off all but lsB   )
ATOM_(maskbyte,maskbyte)
return


 __(============================================= )

__( move		(P from to |||) (cnt ---)  move cnt bytes, overlaps are OK.
			You can't use this with the input buffer and 'this' )
ATOM_(move,move)
DROP
return


 __(============================================= )

__( -?r		( --- flagpyte )  (R c --- c-1) is TOR nonzero before decrement?)
ATOM_(minusaskr,-?r)
BUMP
return


 __(============================================= )

__( NOT		( pyte --- !pyte )   bitwise NOT of all bits	)
ATOM_(NOT,NOT)
return


 __(============================================= )

__( negate		( a --- 2's_complement_negative_a )	)
ATOM_(negate,negate)
return


 __(============================================= )

__( no		( flagpyte --- ) branch to address in ip (the next cell) if 0  )
ATOM_(no,no)
DROP
return


 __(============================================= )

__( over		( a b --- a b a ) the Forth usual OVER, but on pytes.	)
ATOM_(over,over)
BUMP
return


 __(============================================= )

__( onbits		( --- -1 )  all_ones pyte constant, 2's compl. -1 )
ATOM_(onbits,onbits)
BUMP
return

 __(============================================= )

__( one		( --- 1	 ) 1 as a pyte constant	  )
ATOM_(one,one)
BUMP
return

 __(============================================= )

__( OR		( pytea pyteb --- pyteaORb ) bitwise Booolean OR    )
ATOM_(OR,OR)
DROP
return


 __(============================================= )

__( pdrop		(P ptr --- )  decrement pointer stack index )
ATOM_(pdrop,pdrop)
decrement PSI
return


 __(============================================= )

__( p@		(P ptr1	 ---  ptr2 ) ptr1 overwritten )
ATOM_(pfetch,p@)
copy TOPS to A
copy (A) to A
copy A to TOPS
return


 __(============================================= )

__( pdup		(P ptra --- ptra ptra )	 )
ATOM_(pdup,pdup)
return


 __(============================================= )

__( pliteral	(P --- lit )	next cell in thread to P.
		pointless from interpreter, needs a threading wrapper. )
ATOM_(pliteral,pliteral)
return


 __(============================================= )

__( +		( a b --- a+b )	 2's-complement addition of pytes  )
ATOM_(PlUs,+)
DROP
return


 __(============================================= )

__( pover		`pea over'  (P a b --- a b a ) pointer-stack OVER )
ATOM_(pover,pover)
PDROP
copy TOPS to A
PBUMP
PBUMP
copy A to TOPS 
return


 __(============================================= )

__( p+		( pyte --- ) (P a --- a+(int_part_or_less_of)pyte ) )
ATOM_(plusp,p+)
DROP
return


 __(============================================= )

__( p+s		(P a --- a+Size ) index a pointer by Size	)
ATOM_(ppluss,p+s)
return


 __(============================================= )

__( p+1		(P a --- a+1 )	index a pointer by one		)
ATOM_(pplusb,p+1)
return


 __(============================================= )

__( p+c		(P a --- a+cellsize ) index a pointer by cellsize (x86 is 4) )
ATOM_(pplusc,p+c)
return


 __(============================================= )

__( p-c		(P a --- a-cellsize ) decrement pointer by cellsize (4 on x86) )
ATOM_(pminusc,p-c)
return


 __(============================================= )

__( p-1		(P ptr --- ptr+1 ) decrement a pointer			)
ATOM_(pminus1,p-1)
return


 __(============================================= )

__( p->		(P a --- ) ( --- a_low[a_hi] ) if (Size > cellsize) then 0-pad	)

ATOM_(pTO,p->)
BUMP
return


 __(============================================= )

__( p->r		(P a --- ) (R; --- a ) )
ATOM_(pTOr,p->r)
return


 __(============================================= )

__( p->s		(P Size --- )  !Size   superceeded?	)
ATOM_(pTOs,p->s)
return


 __(============================================= )

__( p!		`pea store' (P p  store	 |||  ) p goes in store, no pdrops  )
ATOM_(pstore,p!)
return


 __(============================================= )

__( pswap		(P a b --- b a )	)
ATOM_(pswap,pswap)
return


 __(============================================= )

__( pup		(P ---	oldptr )  pointer stack undrop			)
ATOM_(pup,pup)
return


 __(============================================= )

__( return		(R; xt	--- )  VMST rts to calling thread   )
ATOM_(Return,return)
return			


 __(============================================= )

__( rdrop		(R; a --- ) )
ATOM_(rdrop,rdrop)
return


 __(============================================= )

__( rpcopy		(R; a ||| ) (P --- a ) dup r to p   )
ATOM_(rpcopy,rpcopy)
return


 __(============================================= )

__( r-1		(R: val --- val-1 )  decrement TOR
ATOM_(rminus1,r-1)
return )


 __(============================================= )

__( <-r		(R; val --- ) ( --- 0000val )  4 live bytes written to ds  )
ATOM_(rTO,<-r)
BUMP
copy RSI to TOS
return


 __(============================================= )

__( r->p		(R; ptr --- ) (P --- ptr ) symmetrical with p->r. )
ATOM_(rTOp,r->p)
return


 __(============================================= )

__( r->s		(R; size --- )	!SIZE )
ATOM_(rTOs,r->s)
copy RSI to Size
return


 __( ============================================= )

__( swap		( pytea pyteb --- pyteb pytea ) )
ATOM_(swap,swap)
return


 __(============================================= )

__( setSize	( Size --- )  Silently refuses to set Size to 0. )
ATOM_(setSize,setSize)
DROP
return


 __(============================================= )

__( s->r		(R; --- Size ) Size to return stack		)
ATOM_(sTOr,s->r)
return


 __(============================================= )

__( s->p		(P --- Size )  Size to pointer stack		)
ATOM_(sTOp,s->p)
return


 __(============================================= )
					__( Got milk? )

__( !		(P ptr ||| ) ( pyte --- ) pointer is not dropped )
ATOM_(store,!)
DROP
return


 __( ============================================= )

__( sub		(R; --- ip+ ) ip!   go subthread, other uses. Essence of VMST	)
ATOM_(sub,sub)
return				


 __( ============================================= )

__( ->r		(R; --- val ) ( val --- ) Forth >r, ish. 4 bytes moved. )
ATOM_(TOr,->r)
DROP
return


 __(============================================= )

__( ->code		(P &HNC --- Code_Body_Cell ) )
ATOM_(TOcode,->code)
return


 __(============================================= )

__( ->link		(P &HNC --- Link_Cell ) `to link' field )
ATOM_(TOlink,->link)
return


 __(============================================= )

__( ->p		(P --- CELL ) ( a --- ) CELLSIZE worth of a is moved  )
ATOM_(TOp,->p)
DROP
return


 __(============================================= )

__( true		( --- true_flagpyte ) 0xXXX...ff, true flag pyte constant  )
ATOM_(true,true)
BUMP
return


 __(============================================= )

__( 2pdrop		(P  A B --- )  drop 2 pointers. )
ATOM_(twopdrop,2pdrop)
return

 __(============================================= )

__( upshift	( shiftee amount ---  up-shifted-lo [up-shifted-high] ) )
ATOM_(upshift,upshift)

DROP					__( dsi is shiftee )
return

  __(============================================= )

__( x		( pyte --- ) print & drop a pyte, Forth "." but hex only )
ATOM_(printhex,x)
DROP
return


  __(============================================= )

__( XOR		( pytea pyteb --- pyteaXORb ) bitwise exclusive-or	)
ATOM_(XOR,XOR)
setPTOS
DROP
return


 __(=============================================		)

__( yes		( flagpyte --- )  branch if (lsB of) TOS is true	)
ATOM_(yes,yes)
DROP
return


 __(============================================= )

__( zero		( --- 0 )   0 as a fast pyte-constant  )
ATOM_(zero,zero)

BUMP
return


ATOM_(thxbtixio,<<<THREADS)

 __(` 7777777777777777777777777777777777777777777777777777 ')
 __(` end of dictionary build section for fundamentals/atoms/primitives.
Begin derived words; threads, named noun instances. The above is the
virtual machine, The non-syscall atoms are the virtual CPU.  the following
are some things you can do with said machine. Compiled-in threads are
written in the assembly language of the VM. Note that some of this
proto-H3m code is very un-Forth-like, doing many things wrong. That's
because H3m doesn't really exist yet, just the VM. So, it's nasty
tortuous virtual assembly. As far as examples of using the H3m
interpreter, Note the opcodes used, but ignore the coding style. Very
important in Virtual Machine Subroutine Threading, above here by default
words have the atomic bit set in the Head Name Interface Cell.
m4 macros for all the standard build_a_thread stuff.	'	)

 __( contents of this int is given by  arg			)
define(CELL,	 .int `$1' ; )

 __( this cell contains CFA of word named as argument		)
define(OP,	 .int `$1'CFA )

 __(` VMST jsr, takes a whole cell, plus the callee's cell
This doesn't have the OP folded into it to keep branch offset counting
1:1, except for branch targets. 	'	)
define(SUB,     .int subCFA	)

 __(` build a relative branch offset with integer arg,
$`'1 is +/-, $`'2 is #   +/- needs a comma' )
define(BRANCH,	 .int	 .  `$1' `$2' *4  )

 __( we are at a branch target, set label symbols for here.
targets take no thread space themselves.
The graphicoid name is to emphasize that a cell is not created.	 )
define(___o___,	 	.equ `$1'`_one, .'	)

 __( back-branch address of labels. arg-less macro. )
define(BACK,  	.int `$1'_one	)

__(	NAMED DATA )
__( ddddddddddddddddddddddddddddddd============			)

 
__( block		(P --- begin_buffer) object data buffer(s) )
THREAD_(block,block)
OP(address)
CELL(0)
	.org . + 1024 


__( buffer		(P --- begin_buffer) "file" input buffer )
THREAD_(buffer,buffer)
OP(address)
CELL(0)
	.org . + 2048 


__( bsi		counter for branches to resolve		)
THREAD_(bsi,bsi)
OP(address)
CELL(0)


__( branchstack	space for 16 branches to resolve	)
THREAD_(branchstack,branchstack)
OP(address)
CELL(0)
	.org . + 128 
	__( allot for a maximal pyte )


__( digits		(P  ---	 address_of_array ) ascii vals to hex vals map	)
THREAD_(digits,digits)
OP(address)
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 ) 
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0x00,0x01,0x02,0x03)
ENDIANCELL(0x04,0x05,0x06,0x07)
ENDIANCELL(0x08,0x09,0x00,0x00)
CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0x00,0x0a,0x0b,0x0c)
ENDIANCELL(0x0d,0x0e,0x0f,0x00)
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )


__( dp		(P --- dictionary_free-point_pointer )  pointer, unlike HERE  )
THREAD_(dp,dp)
OP(address)
dpaddy:		
		.int initial_HERE + 1000


__( epa		(P --- &epa )  End Parse Area	pointer		)
THREAD_(epa,epa)
 __(  can't just keep these on a stack because of doHNC	  )
OP(address)
epal:
CELL(0)


__( hexdigits	(P  ---	 &array )  ascii val is/not a hex digit	  )
THREAD_(hexdigits,hexdigits)
       __( could be dual-aligned for unicode. someday. word-size dependant? )
OP(address)
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0xff,0xff,0xff,0xff)
ENDIANCELL(0xff,0xff,0xff,0xff)
ENDIANCELL(0xff,0xff,0x00,0x00)
CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0x00,0xff,0xff,0xff)
ENDIANCELL(0xff,0xff,0xff,0x00)
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )


__( latest		(P --- &HNC ) addr. of HNC of most recent definition  )
THREAD_(latest,latest)
OP(address)		__( data word, does it's own Return.  )
latest:			__( C needs this address for init code	 )
		.int initial_LATEST
CELL(0)


__( pvar		(P --- &pvar)	scratch pointer for thread resolver  )
THREAD_(pvar,pvar)
OP(address)
 CELL(0)


__( rcfile	(P --- &"rcfile")				)
THREAD_(rcfile,rcfile)
OP(address)
 CELL(0)
      	.asciz   "H3smrc" 
	.align 16, 0


__( sourc		(P --- &input_FD) pointer to FD of source of input )
THREAD_(sourc,sourc)
OP(address) 
CELL(0)
         .align 16, 0 


__( thispointer	(P --- &this ) current address in buffered parse area	)
THREAD_(thispointer,thispointer)
OP(address)
CELL(0)


__( toklen		token length	)
THREAD_(toklen,toklen)
OP(address)
CELL(0)


__( targetstack	space for 8 addresses to resolve branches to )
THREAD_(targetstack,targetstack)
OP(address)
CELL(0)
	.org . + 32 
	__( allot for a maximal pyte )


__( tokenbuffer	(P --- &token ) where we stash an input token   )
THREAD_(tb,tb)
OP(address)
CELL(0)
	.org . + 1024 


__( tsi		counter for branches to resolve )
THREAD_(tsi,tsi)
OP(address)
CELL(0)


__( USize		(P --- &USize ) offstack Size store for interpreter
					fetch as a pointer	  )
THREAD_(USize,USize)
OP(address)
CELL(4)				__( x86 cell size )


__( )
__(	THREADS...
)
 __( TTTTTTTTTTTTTTTTTTTTTTTT============				)

  __( ||||||| zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz||============ )

__( zygote		top endless loop, do argv[], do rcfile,  
				then loop over input )
initial_LATEST:		__( label at HNC for dist. init. )
THREAD_(zygote,zygote)
		__( Head execution address, CFA, H3m square zero.
			)
zygote:

OP(onbits)

___o___(top_loop_of_H3sm)
BACK(top_loop_of_H3sm)


 __( ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	)

initial_HERE:

return			__( NEXT ourself to the interpreter... )

 



 __(

Ha3sm 3-stack programming interface (virtual machine design) in m4,
	and GNU "as" for x86.

199804 <--> 200003   Rick Hohensee
humbubba@smart.net	http://www.smart.net/~humbubba

199812	 Michael Somos "http://grail.cba.csuohio.edu/~somos/"
	non-endianness, routine delimiter comment lines, etc.

See also Ertl/Paysan GForth and GNU .info on gcc "labels as values",
the unix section 2 manpages, Linux man 2 intro in particular, and the
GNU .info on gas.

The sourcecode of the "Arith" and "calc" arbitrary precision arithmetic
packages for unices were consulted for this implementation of pyte
arithmetic, although pytes are quite different from numbers in those
systems.

Phil Koopman's book "Stack Computers; The New Wave" bears mention. It is
currently on the web at "http://www.cs.cmu.edu/~koopman/stack_computers/".

Also worth mention are the generally meritocratic and cooperative tones of
comp.lang.forth, MdFIG and linux-kernel@vger.rutgers.edu. Greg Patterson
was helpful at a particularly frustrating moment with C pointers. Two
design features of H3m were suggested by JET Thomas; the single-whole-pass
dictionary search method used by abbreviations, and that pyte sizes go up
to 256 bytes instead of 128. Explanations by Elizabeth Rather and others
in c.l.f led to me eliminating H3m words that access the parameter stack
pointer directly, since a pure stack that has no concept of a "stack
pointer" is sufficient for a stack machine, and probably preferable.  I
had a copy of John Brien's "Build Your Own Forth" webpage in my
/usr/src/H3m . (original URL is
"http://www.users.zetnet.co.uk/aborigine/byof.htm")

The printer Charles Lasitter of Durham, N.C. gave me has done yeoman
service as an essential debugging tool. As have the several PS/2's,
the Pentium, and the cash. I believe the technical term for the likes
of Chuck Lasitter is "angel".

H3m has also recieved direct help from Richard B. Johnson, Brian Raiter,
and direct help or inspiration from various anonymous Internet Relay Chat
personages. The nom_de_IRC's _Anarchy_, tm2, shaver and * come to mind.

As pertains copyrights and release thereof, H3m is not a derived work of
any prior work.

This version of H3m is hereby released into the public domain. I am of
the understanding that "public domain" does not release users of H3m from
the obligation of properly associating my name with the work. Subsequent
work I do on H3m may be released under more restrictive terms.

DESIGN

Virtual Machine Subroutine Threaded H3m.
	All "executable" dictionary cells contain actual addresses of code.
	The address of a sub-word is in the callER, following a "call"
	execution token cell, which is not present in more prevalent
	threading schemes.

Each of the 3 "stacks" has a distinctly different related ops from the other
2.

return
	The return stack will contain only xt's. An xt is what return can use,
	an address space int-ply index to an atom, which is machine code.

pointer
	The H3m pointer stack is cell-sized, but contains only actual host
	address-space pointers usually. Such an entity is called a "pointer"
	from the H3m-user point of view. The pointer stack may be a bridge
	between the H3m VM and the host, but only with specific fundamentals
	for host services, such as system calls. Internally, the pointer stack
	index is usually left pointing to an occupied cell.
data
	The data stack operates on "pytes", groups of 1 <--> 256
	bytes. Boolean flags are the low byte of a pyte. False is zero.
	Non-zero is true. The H3m   true   word asserts 255 in a flagpyte.
	The stack index itself is byte-ply, but pyte operations are at Size.
	The data stack pointer points at the top occupied cell. This is
	important to keep in mind when changing Size.

	Size "Register"

	The current effective size of data stack operands is the Size state
	variable. There are user-visible accessors of this Size "register".
	Operations on pytes are in terms of Size, except where a pyte is
	treated as a flag or character.

So the 3 stacks are the data typing of H3m, in a sense. Typing is enforced
by the various operands. The data stack is where a datum can be treated
arbitrarily.

IMPLEMENTATION

Comments beginning in leftmost character column are appended to the
glossary file by the Glossary script.

)

