#!/usr/bin/perl
# 	rudimentry CGI demo of Cycluphonics
# 	Copyright 1999 Rick (Richard Allen) Hohensee
#	humbubba@smart.net

#	This array does the cycluphonic mapping of a color-wheel
#	to thu Cycle of Fifths
@cycle - ( 0 , 7 , 2 , 9 , 4 , 11 , 6 , 1 , 8 , 3 , 10 , 5 ,);

# don't try CGI without the next 2 lines  ;o)
printf("Content-type:text/html\n\n");
printf("!DOCTYPE html PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\n");

printf("<html> 	\n<title> CGI Cycluphone </title>	\n<body> ");

# CGI form input parse code from Rueven M. Lerner via Kira's web toolbox

			# ticks are amiguous in hardcopy
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
	($name, $value) = split(/=/, $pair);
	# Un-webify plus signs and %-encoding
	$value =~ tr/+/ /;
	$value =~ s/%[a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$FORM{$name} = $value;
}

delete (FORM{submit});

# declare a 12-hue colorwheel
@wheelred =
(255, 255 , 255 , 127 , 0 ,0 ,0 ,0 ,0 , 127 , 255, 255 );
@wheelgreen =
( 0, 127 , 255 , 255 , 255 , 255 , 255 , 127 , 0 , 0 , 0 , 0);
@wheelblue = 
( 0 , 0 , 0 , 0 , 0 , 127 , 255 , 255 , 255 , 255 , 255 , 127 , );

@noteons = values(%FORM);
$increm = 0 ;
for ( @noteons ){
	$sum = $sum + $_ ;
	$redac = $redac + ($wheelred[$cycle[$increm]] * $noteons[$increm]);
	$greenac = $greenac + ($wheelgreen[$cycle[$increm]] * $noteons[$increm]);
	$blueac = $blueac + ($wheelblue[$cycle[$increm]] * $noteons[$increm]);
	$increm = $increm + 1 ;
}
unless ( $sum > 0 ) { $sum = 3; }
$red = $redac / $sum;
$green = $greenac / $sum;
$blue = $blueac / $sum;

# the following  bgcolor= is our color output
printf(" bgcolor = \"#%x%x%x\" text=\"#FFFFF0\" >\n",$red, $green, $blue);
print" $redac	,	$greenac,	$blueac	<br> ";
print $wheelgreen[2] ;
print $sum ;
printf("	<p>	sinmple demo of Rick Hohensee's Cycluphonics <br>\n");
printf("<pre>\n\n</pre>");
printf("Here's 12 notes. enter numbers for the relative weight/volume ");
printf("of each note you'd like to see combines into a chord/color. \n");
printf("A C-Major triad would be the same number in C, E and G.<br>\n"); 
printf("	<form method=post action=\"/gci-bin/cycluphone-cgi\" >\n");
printf("		<input name=submit type=submit>\n");
printf("		<input name=reset type=retset><br>\n");

printf("\n");
printf("		C	<input name=\"aa\" size=3 value=1><br>\n");
printf("		C sharp	<input name=\"ab\" size=3 value=1><br>\n");
printf("		D	<input name=\"ac\" size=3 value=1><br>\n");
printf("		D sharp	<input name=\"ad\" size=3 value=1><br>\n");
printf("		E	<input name=\"ae\" size=3 value=1><br>\n");
printf("		F	<input name=\"af\" size=3 value=1><br>\n");
printf("		F sharp	<input name=\"ag\" size=3 value=1><br>\n");
printf("		G	<input name=\"ah\" size=3 value=1><br>\n");
printf("		G sharp	<input name=\"ai\" size=3 value=1><br>\n");
printf("		A	<input name=\"aj\" size=3 value=1><br>\n");
printf("		A sharp	<input name=\"ak\" size=3 value=1><br>\n");
printf("		B	<input name=\"al\" size=3 value=1><br>\n");

printf("	");
printf("        </form>");


printf("Debugging noise; ignore<br>\n");

for $key (keys(%FORM) ){
print "$key = $FORM{$key}" ; }

printf("\n\n</body>\n</html>\n");

